(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15026,        418]
NotebookOptionsPosition[     13373,        382]
NotebookOutlinePosition[     13772,        398]
CellTagsIndexPosition[     13729,        395]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Quintic Spline Generator", "Subtitle",
 CellChangeTimes->{{3.812353928354472*^9, 
  3.812353934160544*^9}},ExpressionUUID->"49c4c500-4bca-43fe-93e9-\
78ce2c1ef69c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"r", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{"a", " ", 
    SuperscriptBox["t", "5"]}], "+", 
   RowBox[{"b", " ", 
    SuperscriptBox["t", "4"]}], "+", 
   RowBox[{"c", " ", 
    SuperscriptBox["t", "3"]}], "+", 
   RowBox[{"d", " ", 
    SuperscriptBox["t", "2"]}], "+", 
   RowBox[{"e", " ", "t"}], "+", "f"}]}]], "Input",
 CellChangeTimes->{{3.812274198148899*^9, 3.8122742330843363`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"bbf5bef9-06a2-42d0-a385-df0fa3ad505f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"r", "[", "0", "]"}], "\[Equal]", "x0"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "'"}], "[", "0", "]"}], "\[Equal]", "v0"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "''"}], "[", "0", "]"}], "\[Equal]", "a0"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"r", "[", "tf", "]"}], "\[Equal]", "xf"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "'"}], "[", "tf", "]"}], "\[Equal]", "vf"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "''"}], "[", "tf", "]"}], "\[Equal]", "af"}]}], 
      "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
      "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8122742397411203`*^9, 3.8122742971169167`*^9}, {
  3.812274409895113*^9, 3.8122744109341383`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"d2dfbb51-4c09-4581-9aa3-86a1fd092da5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"a0", " ", 
        SuperscriptBox["tf", "2"]}], "-", 
       RowBox[{"af", " ", 
        SuperscriptBox["tf", "2"]}], "+", 
       RowBox[{"6", " ", "tf", " ", "v0"}], "+", 
       RowBox[{"6", " ", "tf", " ", "vf"}], "+", 
       RowBox[{"12", " ", "x0"}], "-", 
       RowBox[{"12", " ", "xf"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["tf", "5"]}]]}]}], ",", 
   RowBox[{"b", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", "a0", " ", 
        SuperscriptBox["tf", "2"]}], "+", 
       RowBox[{"2", " ", "af", " ", 
        SuperscriptBox["tf", "2"]}], "-", 
       RowBox[{"16", " ", "tf", " ", "v0"}], "-", 
       RowBox[{"14", " ", "tf", " ", "vf"}], "-", 
       RowBox[{"30", " ", "x0"}], "+", 
       RowBox[{"30", " ", "xf"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["tf", "4"]}]]}]}], ",", 
   RowBox[{"c", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"3", " ", "a0", " ", 
        SuperscriptBox["tf", "2"]}], "-", 
       RowBox[{"af", " ", 
        SuperscriptBox["tf", "2"]}], "+", 
       RowBox[{"12", " ", "tf", " ", "v0"}], "+", 
       RowBox[{"8", " ", "tf", " ", "vf"}], "+", 
       RowBox[{"20", " ", "x0"}], "-", 
       RowBox[{"20", " ", "xf"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["tf", "3"]}]]}]}], ",", 
   RowBox[{"d", "\[Rule]", 
    FractionBox["a0", "2"]}], ",", 
   RowBox[{"e", "\[Rule]", "v0"}], ",", 
   RowBox[{"f", "\[Rule]", "x0"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.812274288494832*^9, 3.812274297503636*^9}, 
   3.812274411272402*^9, {3.812353943604505*^9, 3.812353946254325*^9}, 
   3.812366289675829*^9, 3.81415978575902*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"6b34bb2b-ef07-457e-93a9-ed0db6aac60b"]
}, Open  ]],

Cell["Find Maximum of Velocity, Acceleration, and Jerk", "Text",
 CellChangeTimes->{{3.812354010301882*^9, 
  3.812354019986682*^9}},ExpressionUUID->"150a2e9b-cfd9-47f1-963c-\
d508da0e68a0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxJerkT", "=", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"r", "''''"}], "[", "t", "]"}], "\[Equal]", "0"}], ",", "t"}],
      "]"}], "/.", "res"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"maxJerkTf", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"r", "'''"}], "[", "t", "]"}], "/.", 
          RowBox[{"maxJerkT", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "/.", "res"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"a0", "\[Rule]", "0"}], ",", 
          RowBox[{"af", "\[Rule]", "0"}], ",", 
          RowBox[{"v0", "\[Rule]", "0"}], ",", 
          RowBox[{"vf", "\[Rule]", "0"}]}], "}"}]}], ")"}], "\[Equal]", 
      "jMax"}], ",", "tf"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.81235396112649*^9, 3.812353984009347*^9}, {
   3.812354030048271*^9, 3.81235422994519*^9}, {3.812354262794305*^9, 
   3.812354442841771*^9}, {3.812354698451507*^9, 3.812354709526368*^9}, {
   3.8123662941358967`*^9, 3.81236629529646*^9}, {3.8123663356866426`*^9, 
   3.812366337582245*^9}, {3.812366417190226*^9, 3.812366514519258*^9}, {
   3.812369893128203*^9, 3.8123699190234337`*^9}, {3.81237000708965*^9, 
   3.812370146408964*^9}, {3.812370478232766*^9, 3.812370480814286*^9}, {
   3.814159840955447*^9, 3.814159893546583*^9}, {3.814159929291947*^9, 
   3.814160028035316*^9}, {3.814160125052609*^9, 3.814160138860087*^9}, 
   3.814160172781646*^9, {3.814160237389709*^9, 3.814160239149007*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"2e466dc4-e8ae-4ba0-a21c-ad42c0ce4a37"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"tf", "\[Rule]", 
   FractionBox[
    RowBox[{
     SuperscriptBox["30", 
      RowBox[{"1", "/", "3"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"x0", "-", "xf"}], ")"}], 
      RowBox[{"1", "/", "3"}]]}], 
    SuperscriptBox["jMax", 
     RowBox[{"1", "/", "3"}]]]}], "}"}]], "Output",
 CellChangeTimes->{{3.8123539668694763`*^9, 3.812353984505331*^9}, {
   3.812354032404314*^9, 3.812354130783642*^9}, {3.81235416170765*^9, 
   3.812354230330439*^9}, {3.812354265106627*^9, 3.81235444308022*^9}, 
   3.812354473761189*^9, {3.812354700185112*^9, 3.8123547099095573`*^9}, 
   3.812366295657493*^9, 3.8123663385962677`*^9, {3.8123664182841587`*^9, 
   3.812366514877822*^9}, {3.812369895412538*^9, 3.8123699193905497`*^9}, {
   3.812370017996215*^9, 3.812370146880855*^9}, {3.8123704785834427`*^9, 
   3.812370481181272*^9}, 3.814159788909965*^9, {3.8141598464534082`*^9, 
   3.814159894112802*^9}, {3.8141599297775917`*^9, 3.8141600285226192`*^9}, {
   3.8141601255205812`*^9, 3.814160139122129*^9}, 3.8141601736174183`*^9, 
   3.814160239512063*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"9297535f-d9cb-469c-8a2f-2277fbb42a0d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxAccT", "=", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"r", "'''"}], "[", "t", "]"}], "\[Equal]", "0"}], ",", "t"}], 
     "]"}], "/.", "res"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"maxAccTf", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"r", "''"}], "[", "t", "]"}], "/.", "res"}], "/.", 
         RowBox[{"maxAccT", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"a0", "\[Rule]", "0"}], ",", 
          RowBox[{"af", "\[Rule]", "0"}], ",", 
          RowBox[{"v0", "\[Rule]", "0"}], ",", 
          RowBox[{"vf", "\[Rule]", "0"}]}], "}"}]}], ")"}], "\[Equal]", 
      "aMax"}], ",", "tf"}], "]"}], "[", 
   RowBox[{"[", "4", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8123544651987257`*^9, 3.812354584370565*^9}, {
  3.812354662747362*^9, 3.812354692210718*^9}, {3.812366284426289*^9, 
  3.812366285799551*^9}, {3.8123663405313683`*^9, 3.812366344098298*^9}, {
  3.814160261357587*^9, 3.8141602619651337`*^9}, {3.81416029352555*^9, 
  3.814160293628995*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"5fe6730b-ea10-4a0c-ac7a-37c7ada0a707"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"tf", "\[Rule]", 
   FractionBox[
    RowBox[{
     SqrtBox["10"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["x0", "2"], "-", 
        RowBox[{"2", " ", "x0", " ", "xf"}], "+", 
        SuperscriptBox["xf", "2"]}], ")"}], 
      RowBox[{"1", "/", "4"}]]}], 
    RowBox[{
     SuperscriptBox["3", 
      RowBox[{"1", "/", "4"}]], " ", 
     SqrtBox["aMax"]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.812354480268215*^9, 3.812354584816472*^9}, {
   3.812354667233481*^9, 3.8123546926717653`*^9}, {3.812366286609042*^9, 
   3.812366297765739*^9}, 3.812366344654502*^9, 3.8123834634152727`*^9, 
   3.8141598023472147`*^9, {3.814160259226156*^9, 3.814160294736022*^9}},
 CellLabel->
  "Out[108]=",ExpressionUUID->"5196904a-7b5f-4545-a07c-7fb4254d1db9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxVelT", "=", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"r", "''"}], "[", "t", "]"}], "\[Equal]", "0"}], ",", "t"}], 
     "]"}], "/.", "res"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"maxVelTf", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"r", "'"}], "[", "t", "]"}], "/.", "res"}], "/.", 
         RowBox[{"maxVelT", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"a0", "\[Rule]", "0"}], ",", 
          RowBox[{"af", "\[Rule]", "0"}], ",", 
          RowBox[{"v0", "\[Rule]", "0"}], ",", 
          RowBox[{"vf", "\[Rule]", "0"}]}], "}"}]}], ")"}], "\[Equal]", 
      "vMax"}], ",", "tf"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.812354592830155*^9, 3.812354686867679*^9}, {
  3.812366300774168*^9, 3.812366301992361*^9}, {3.812366346210133*^9, 
  3.812366347721609*^9}, {3.812370560741046*^9, 3.812370584352597*^9}, {
  3.814159813539048*^9, 3.81415981419401*^9}, {3.814160297957967*^9, 
  3.814160306189053*^9}},
 CellLabel->
  "In[113]:=",ExpressionUUID->"50603568-f240-4489-934b-d9cfa2d95318"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"tf", "\[Rule]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"15", " ", 
      RowBox[{"(", 
       RowBox[{"x0", "-", "xf"}], ")"}]}], 
     RowBox[{"8", " ", "vMax"}]]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.812354624090929*^9, 3.812354687584631*^9}, 
   3.812366302731291*^9, 3.8123663485390778`*^9, {3.812370561051642*^9, 
   3.8123705987155867`*^9}, 3.81238336165096*^9, {3.81415981049634*^9, 
   3.8141598150883217`*^9}, {3.814160296551602*^9, 3.814160306805706*^9}},
 CellLabel->
  "Out[114]=",ExpressionUUID->"826715a6-d289-4ff5-861d-1653e0d76163"]
}, Open  ]],

Cell["Plot Examples", "Text",
 CellChangeTimes->{{3.812366321001575*^9, 
  3.812366322825717*^9}},ExpressionUUID->"dd20d9e9-61a2-4cfa-a470-\
400e57447904"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x0", "\[Rule]", "0"}], ",", 
     RowBox[{"v0", "\[Rule]", "1"}], ",", 
     RowBox[{"a0", "\[Rule]", "0"}], ",", 
     RowBox[{"xf", "\[Rule]", "1"}], ",", 
     RowBox[{"vf", "\[Rule]", "0"}], ",", 
     RowBox[{"af", "\[Rule]", "0"}], ",", 
     RowBox[{"vMax", "\[Rule]", "1"}], ",", 
     RowBox[{"aMax", "\[Rule]", "1"}], ",", 
     RowBox[{"jMax", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"r", "'''"}], "[", "t", "]"}], "/.", "res"}], "/.", "data"}],
       "/.", "tfdata"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.8123663302969103`*^9, 3.812366428832733*^9}, {
   3.812366526224143*^9, 3.812366578067265*^9}, {3.81236672262925*^9, 
   3.812366723078273*^9}, {3.812366758931038*^9, 3.812366780849244*^9}, {
   3.812369772962038*^9, 3.812369888193581*^9}, {3.812383478184202*^9, 
   3.8123834786651278`*^9}, 3.817524867469405*^9},
 CellLabel->
  "In[199]:=",ExpressionUUID->"f40b15f2-ed60-47f6-91af-891adbe8ec3c"]
}, Open  ]]
},
WindowSize->{1848, 1016},
WindowMargins->{{-1988, Automatic}, {170, Automatic}},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"971fc96e-ed58-4adf-b858-d5cb5b702476"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 170, 3, 53, "Subtitle",ExpressionUUID->"49c4c500-4bca-43fe-93e9-78ce2c1ef69c"],
Cell[753, 27, 512, 14, 30, "Input",ExpressionUUID->"bbf5bef9-06a2-42d0-a385-df0fa3ad505f"],
Cell[CellGroupData[{
Cell[1290, 45, 1286, 35, 178, "Input",ExpressionUUID->"d2dfbb51-4c09-4581-9aa3-86a1fd092da5"],
Cell[2579, 82, 1923, 53, 55, "Output",ExpressionUUID->"6b34bb2b-ef07-457e-93a9-ed0db6aac60b"]
}, Open  ]],
Cell[4517, 138, 190, 3, 35, "Text",ExpressionUUID->"150a2e9b-cfd9-47f1-963c-d508da0e68a0"],
Cell[CellGroupData[{
Cell[4732, 145, 1772, 42, 52, "Input",ExpressionUUID->"2e466dc4-e8ae-4ba0-a21c-ad42c0ce4a37"],
Cell[6507, 189, 1195, 25, 57, "Output",ExpressionUUID->"9297535f-d9cb-469c-8a2f-2277fbb42a0d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7739, 219, 1354, 37, 52, "Input",ExpressionUUID->"5fe6730b-ea10-4a0c-ac7a-37c7ada0a707"],
Cell[9096, 258, 833, 22, 61, "Output",ExpressionUUID->"5196904a-7b5f-4545-a07c-7fb4254d1db9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9966, 285, 1346, 37, 52, "Input",ExpressionUUID->"50603568-f240-4489-934b-d9cfa2d95318"],
Cell[11315, 324, 604, 14, 52, "Output",ExpressionUUID->"826715a6-d289-4ff5-861d-1653e0d76163"]
}, Open  ]],
Cell[11934, 341, 155, 3, 35, "Text",ExpressionUUID->"dd20d9e9-61a2-4cfa-a470-400e57447904"],
Cell[12092, 346, 1265, 33, 107, "Input",ExpressionUUID->"f40b15f2-ed60-47f6-91af-891adbe8ec3c"]
}, Open  ]]
}
]
*)

